#ifndef TETRIS_GAME_H
#define TETRIS_GAME_H
#include <vector>
#include <SFML/Graphics.hpp>
#include "Block.h"

class Game {
public:
    static Game& get();
    Game(const Game&) = delete;
    Game(Game&&) = delete;
    Game& operator=(const Game&) = delete;
    Game& operator=(Game&&) = delete;
    void step(Block& objects);
    void move(Block &obj, const sf::Event& event);
    bool canMove(const Block& obj);
    void contains(std::vector<sf::Vector2f> poss);
    bool isEmpty(sf::Vector2f pos) const;
    bool isFullLine(std::array<bool,21> line);
    void deleteLine(std::vector<Block>& blocks);
private:
    int score;
    std::array<std::array<bool,21>,21> m_board{};
    Game() {};
};


#endif //TETRIS_GAME_H
