#include "../include/Block.h"
#include <iostream>

void Block::create(const Shape& shape) {
    switch (shape) {
        case Shape::I:
            m_blocks.push_back(  1 );
            m_blocks.push_back(  5 );
            m_blocks.push_back(  9 );
            m_blocks.push_back( 13 );
            break;
        case Shape::T:
            m_blocks.push_back( 4 );
            m_blocks.push_back( 5 );
            m_blocks.push_back( 6 );
            m_blocks.push_back( 9 );
            break;
        case Shape::O:
            m_blocks.push_back( 4 );
            m_blocks.push_back( 5 );
            m_blocks.push_back( 8 );
            m_blocks.push_back( 9 );
            break;
        case Shape::L:
            m_blocks.push_back( 0 );
            m_blocks.push_back( 4 );
            m_blocks.push_back( 8 );
            m_blocks.push_back( 9 );
            break;
        case Shape::J:
            m_blocks.push_back( 1 );
            m_blocks.push_back( 5 );
            m_blocks.push_back( 8 );
            m_blocks.push_back( 9 );
            break;
        case Shape::S:
            m_blocks.push_back( 5 );
            m_blocks.push_back( 6 );
            m_blocks.push_back( 8 );
            m_blocks.push_back( 9 );
            break;
        case Shape::Z:
            m_blocks.push_back( 4 );
            m_blocks.push_back( 5 );
            m_blocks.push_back( 9 );
            m_blocks.push_back(10 );
            break;
    }
    for (const auto& a : m_blocks)
    pos.emplace_back( static_cast<float>(a%4)*10.f, static_cast<float>(a/4)*10.f);
}

void Block::rotate() {
    constexpr std::array<int, 4> oddI = { 0, 1, -1, -2 };

    constexpr std::array<int, 4> oddTx = {0, -1, -2, 0 };
    constexpr std::array<int, 4> oddTy = {2, 1, 0, 0 };
    constexpr std::array<int, 4> odd2Tx = { 2, 1, 0, 0 };
    constexpr std::array<int, 4> odd2Ty = { 0, 1, 2, 0 };
    constexpr std::array<int, 4> odd3Tx = { 0, 1, 2, 0 };
    constexpr std::array<int, 4> odd3Ty = { -2, -1, 0, 0 };
    constexpr std::array<int, 4> odd4Tx = { -2, -1, 0, 0 };
    constexpr std::array<int, 4> odd4Ty = { 0, -1, -2, 0 };

    constexpr std::array<int, 4> oddLx = { 2, 1, 0, -1 };
    constexpr std::array<int, 4> oddLy = { 0, -1, -2, -1 };
    constexpr std::array<int, 4> odd2Lx = { 0, 1, 2, 1 };
    constexpr std::array<int, 4> odd2Ly = { 2, 1, 0, -1 };
    constexpr std::array<int, 4> odd3Lx = { -2, -1, 0, 1 };
    constexpr std::array<int, 4> odd3Ly = { 0, 1, 2, 1 };
    constexpr std::array<int, 4> odd4Lx = { 0, -1, -2, -1 };
    constexpr std::array<int, 4> odd4Ly = { -2, -1, 0, 1 };

    constexpr std::array<int, 4> oddJx = { 1, 0, 0, -1 };
    constexpr std::array<int, 4> oddJy = { 2, 1, -1, 0 };
    constexpr std::array<int, 4> odd2Jx = { -2, -1, 1, 0 };
    constexpr std::array<int, 4> odd2Jy = { 0, -1, -1, -2 };
    constexpr std::array<int, 4> odd3Jx = { 0, 1, 1, 2 };
    constexpr std::array<int, 4> odd3Jy = { -2, -1, 1, 0 };
    constexpr std::array<int, 4> odd4Jx = { 1, 0, -2, -1 };
    constexpr std::array<int, 4> odd4Jy = { 0, 1, 1, 2 };

    constexpr std::array<int, 4> oddSx = { -1, -2, 1, 0 };
    constexpr std::array<int, 4> oddSy = { 0, -1, -1, 0 };

    constexpr std::array<int, 4> oddZx = { 2, 1, 0, -1 };
    constexpr std::array<int, 4> oddZy = { -1, 0, -1, 0 };
    switch (m_shape) {
        case Shape::I:
            if (m_blocks[0]==1) {
                m_blocks[0] = 0;
                m_blocks[1] = 1;
                m_blocks[2] = 2;
                m_blocks[3] = 3;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x-oddI[i]*10.f , (pos[i].y-i*10.f)};
                }
            } else {
                m_blocks[0] = 1;
                m_blocks[1] = 5;
                m_blocks[2] = 9;
                m_blocks[3] = 13;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x+oddI[i]*10.f , (pos[i].y+i*10.f)};
                }
            }
            break;
        case Shape::T:
            if (m_blocks[0]==4) {
                m_blocks[0] = 12;
                m_blocks[1] = 8;
                m_blocks[2] = 4;
                m_blocks[3] = 9;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + oddTx[i] * 10.f , (pos[i].y + oddTy[i] * 10.f)};
                }
            } else
            if (m_blocks[0]==12) {
                m_blocks[0] = 14;
                m_blocks[1] = 13;
                m_blocks[2] = 12;
                m_blocks[3] = 9;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + odd2Tx[i] * 10.f , (pos[i].y + odd2Ty[i] * 10.f)};
                }
            } else
            if (m_blocks[0]==14) {
                m_blocks[0] = 8;
                m_blocks[1] = 10;
                m_blocks[2] = 6;
                m_blocks[3] = 9;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + odd3Tx[i] * 10.f , (pos[i].y + odd3Ty[i] * 10.f)};
                }
            }
            else {
                m_blocks[0] = 4;
                m_blocks[1] = 5;
                m_blocks[2] = 6;
                m_blocks[3] = 9;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + odd4Tx[i] * 10.f , (pos[i].y + odd4Ty[i] * 10.f)};
                }
            }
            break;
        case Shape::O:
            break;
        case Shape::L:
            if (m_blocks[0]==0) {
                m_blocks[0] = 2;
                m_blocks[1] = 1;
                m_blocks[2] = 0;
                m_blocks[3] = 4;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + oddLx[i] * 10.f , pos[i].y + oddLy[i] * 10.f};
                }
            } else
            if (m_blocks[0]==2) {
                m_blocks[0] = 11;
                m_blocks[1] = 7;
                m_blocks[2] = 3;
                m_blocks[3] = 2;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + odd2Lx[i] * 10.f , (pos[i].y + odd2Ly[i] * 10.f)};
                }
            } else
            if (m_blocks[0]==11) {
                m_blocks[0] = 4;
                m_blocks[1] = 9;
                m_blocks[2] = 10;
                m_blocks[3] = 6;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + odd3Lx[i] * 10.f , (pos[i].y + odd3Ly[i] * 10.f)};
                }
            }
            else {
                m_blocks[0] = 0;
                m_blocks[1] = 4;
                m_blocks[2] = 8;
                m_blocks[3] = 9;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + odd4Lx[i] * 10.f , (pos[i].y + odd4Ly[i] * 10.f)};
                }
            }
            break;
        case Shape::J:
            if (m_blocks[0]==1) {
                m_blocks[0] = 10;
                m_blocks[1] = 9;
                m_blocks[2] = 4;
                m_blocks[3] = 8;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + oddJx[i] * 10.f , pos[i].y + oddJy[i] * 10.f};
                }
            } else
            if (m_blocks[0]==10) {
                m_blocks[0] = 8;
                m_blocks[1] = 4;
                m_blocks[2] = 1;
                m_blocks[3] = 0;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + odd2Jx[i] * 10.f , (pos[i].y + odd2Jy[i] * 10.f)};
                }
            } else
            if (m_blocks[0]==8) {
                m_blocks[0] = 0;
                m_blocks[1] = 1;
                m_blocks[2] = 6;
                m_blocks[3] = 2;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + odd3Jx[i] * 10.f , (pos[i].y + odd3Jy[i] * 10.f)};
                }
            }
            else {
                m_blocks[0] = 1;
                m_blocks[1] = 5;
                m_blocks[2] = 8;
                m_blocks[3] = 9;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x + odd4Jx[i] * 10.f , (pos[i].y + odd4Jy[i] * 10.f)};
                }
            }
            break;
        case Shape::S:
            if (m_blocks[0]==5) {
                m_blocks[0] = 4;
                m_blocks[1] = 0;
                m_blocks[2] = 5;
                m_blocks[3] = 9;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x+oddSx[i]*10.f , (pos[i].y+oddSy[i]*10.f)};
                }
            } else {
                m_blocks[0] = 5;
                m_blocks[1] = 6;
                m_blocks[2] = 8;
                m_blocks[3] = 9;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x-oddSx[i]*10.f , (pos[i].y-oddSy[i]*10.f)};
                }
            }
            break;
        case Shape::Z:
            if (m_blocks[0]==4) {
                m_blocks[0] = 2;
                m_blocks[1] = 6;
                m_blocks[2] = 5;
                m_blocks[3] = 9;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x+oddZx[i]*10.f , (pos[i].y+oddZy[i]*10.f)};
                }
            } else {
                m_blocks[0] = 4;
                m_blocks[1] = 5;
                m_blocks[2] = 9;
                m_blocks[3] = 10;
                for (size_t i = 0; i < m_blocks.size(); ++i) {
                    pos[i]={pos[i].x-oddZx[i]*10.f , (pos[i].y-oddZy[i]*10.f)};
                }
            }
            break;
    }
}

std::vector<sf::RectangleShape>& Block::draw() {
    m_shapes.resize(m_blocks.size());
    int i = 0;
    for(auto& s : m_shapes) {
        s.setSize(sf::Vector2f(10,10));
        s.setFillColor(sf::Color::Green);
        s.setPosition(pos[i]);
        i++;
    }
    return m_shapes;
}

Block::Block(const Shape& shape): m_shape{shape} {
    init();
}

void Block::setPosition(const std::vector<sf::Vector2f>& vec) {
    pos = vec;
}

const std::vector<sf::Vector2f>& Block::getPosition() const {
    return pos;
}

void Block::setBlocks(const std::vector<uint8_t> &new_blocks) {
    m_blocks = new_blocks;
}
