#include "../include/Game.h"
#include <iostream>

void Game::contains(std::vector<sf::Vector2f> poss) {
    for (auto & pos : poss)
        m_board.at(pos.y/10).at(pos.x/10) = true;
    std::cout<<"START_BOARD\n";
    for (auto a: m_board) {
        for (auto b : a) {
            if (b) std::cout<<"t";
            else std::cout<<".";
        }
        std::cout<<"\n";
    }
    std::cout<<"END_BOARD\n";
}

void Game::step(Block& objects) {
    std::vector<sf::Vector2f> newPos;
    std::vector<sf::Vector2f> actualPos;
    actualPos = objects.getPosition();
    for (const auto & a : actualPos) {
        if (a.y>190) {
            m_board.at(a.y/10).at(a.x/10) = true;
            return;
        }
    }
    for (auto & actualPo : actualPos) {
        actualPo.y += 10;
        if (!isEmpty(actualPo)) {
            actualPo.y -= 10;
            return;
        }
    }
        newPos = actualPos;
        objects.setPosition(newPos);

}

void Game::move(Block &obj, const sf::Event& event) {
    auto positions = obj.getPosition();
    for (const auto & a : obj.getPosition()) {
        if (a.y>190) {
                m_board.at(a.y/10).at(a.x/10) = true;
            return;
        }
    }

    if (event.key.code==sf::Keyboard::Right) {
        for (auto& a : positions) {
            if (a.x > 190) return;
            a.x+=10;
            if (!isEmpty(a)) {
                a.x-=10;
                return;
            }
        }
    }

    if (event.key.code==sf::Keyboard::Left) {
        for (auto& a : positions) {
            if (a.x < 10) return;
            a.x-=10;
            if (!isEmpty(a)) {
                a.x+=10;
                return;
            }
        }
    }
    if (event.key.code==sf::Keyboard::Down) {
        for (auto& a : positions) {
            if (a.y>190) break;
            a.y+=10;
            if (!isEmpty(a)) {
                a.y-=10;
                return;
            }
        }
    }
    obj.setPosition(positions);
}

bool Game::canMove(const Block& obj) {
    for (const auto& pos : obj.getPosition()) {
        if (pos.y>190) {
            for (const auto& a : obj.getPosition()) {
                m_board.at(a.y/10).at(a.x/10) = true;
            }
            return false;
        }
    }
    for (const auto& pos : obj.getPosition()) {
        auto futurePos = pos;
        futurePos.y+=10;
        if( !isEmpty(futurePos) ) return false;
    }
    return true;
}

bool Game::isEmpty(sf::Vector2f pos) const {
    if (m_board.at(pos.y / 10).at(pos.x / 10))
        return false;
    else
        return true;
}

bool Game::isFullLine(std::array<bool, 21> line) {
    int fill{0};
    for (const auto& a: line) {
        if (a) fill++;
        if(fill==21) return true;
    }
    return false;
}

void Game::deleteLine(std::vector<Block>& blocks) {
    int lines{0};
    for ( auto& line : m_board) {
        if (isFullLine(line)) {
            for ( auto& a : blocks) {
                auto pos = a.getPosition();
                auto block = a.getBlocks();
                std::cout<<"size m_blocks: "<<block.size()<<"\n";
                auto it2 = block.begin();
                std::cout<<"Old size: "<<pos.size()<<"\n";
                for (auto& p : pos) {
                    p.y+=10;
                }
                for (auto it = pos.begin() ; it != pos.end()-1; ) {
                    if (it->y > 190) {
                        pos.erase(it);
                        block.erase(it2);

                    } else {
                        ++it;
                        ++it2;
                    }
                }
                std::cout<<"New size: "<<pos.size()<<"\n";
                a.setPosition(pos);
            }
            std::cout<<lines<<"\n";
            for (size_t i = lines - 1; i > 0; --i) {
                m_board.at(i + 1) = m_board[i];
            }
        }
        lines++;
    }
}

Game& Game::get() {
    static Game* g = new Game();
    return *g;
}
