#include <random>
#include <SFML/Graphics.hpp>
#include "../include/Block.h"
#include "../include/Game.h"

int main() {
    sf::Time dt;
    sf::Clock clock;
    sf::RenderWindow window(sf::VideoMode(220, 220), "TetrisSFML 2!");
    window.setFramerateLimit(60);
    std::random_device rd{};
    std::mt19937 mt(rd());
    std::uniform_int_distribution dist(1, 7);

    std::vector<Block> blocks;
    blocks.emplace_back((Shape) dist(mt));
    clock.restart();
    while (window.isOpen()) {
        sf::Event event{};
        while (window.pollEvent(event)) {
            if (event.type == sf::Event::Closed)
                window.close();
            if ((event.type == sf::Event::KeyPressed) && (event.key.code == sf::Keyboard::Escape))
                window.close();
            if((event.type == sf::Event::KeyPressed) && ((event.key.code == sf::Keyboard::Right)
            || (event.key.code == sf::Keyboard::Left)))
                Game::get().move(blocks.at(blocks.size() - 1), event);
            if((event.type == sf::Event::KeyPressed) && ((event.key.code == sf::Keyboard::Down)))
                Game::get().move(blocks.at(blocks.size() - 1), event);
            if((event.type == sf::Event::KeyPressed) && ((event.key.code == sf::Keyboard::Up)))
                blocks.at(blocks.size() - 1).rotate();
        }
        auto next_shape = (Shape) dist(mt);
        if ( !Game::get().canMove(blocks.at(blocks.size() - 1)) ) {
            Game::get().contains(blocks.at(blocks.size() - 1).getPosition());
            blocks.push_back(next_shape );
            Game::get().deleteLine(blocks);
        }
        window.clear();
        for (auto& block : blocks ) {
            auto s = block.draw();
            for (const auto& a : s ){
                window.draw(a);
            }
        }
        window.display();
        dt = clock.getElapsedTime();
        if (dt.asMilliseconds()>500){
            Game::get().step(blocks.at(blocks.size() - 1));
            clock.restart();
        }
    }
    return 0;
}
